﻿;http://devernay.free.fr/hacks/chip8/C8TECH10.HTM#memmap
;0x000 (0) Start of Chip-8 RAM Interpreter code, fonts
;0x200 (512) Start of most Chip-8 programs
;0x600 (1536) Start of ETI 660 Chip-8 programs
;0xFFF (4095) End of Chip-8 RAM
;https://tonisagrista.com/blog/2021/chip8-spec/

Enumeration
  #da
EndEnumeration

Enumeration
  #type_code
  #type_byte
  #type_pair
EndEnumeration

Enumeration ;menu
  #mark_code
  #mark_byte
  #mark_pair
  #mark_comment
  #file_open
  #file_save
  #file_quit
  #opt_labels
EndEnumeration

Structure comline
  addr.s
  remark.s
EndStructure

Global *m=AllocateMemory(4096)
Global Dim t(4096) ; types
Global fs
Global mitem.l
Global spath$

Global NewList Labels.s{4}()
Global NewList comments.comline()

Procedure.s w2s(n.w)
  ProcedureReturn RSet(Hex(n),4,"0")
EndProcedure

Procedure.s b2s(b.b)
  ProcedureReturn Hex(b)
EndProcedure

Procedure.s bb2s(b.a)
  ProcedureReturn RSet(Hex(b),2,"0")
EndProcedure

Procedure das()
  ClearList(Labels())
  ClearList(comments())
  ;---create list of cooments
  ln=CountGadgetItems(#da)
  If ln
    For i=0 To ln-1
      l$=GetGadgetItemText(#da,i)
      If Mid(l$,1,1)="L"
        l$=Mid(l$,2)
      EndIf
      po=FindString(l$,";")
      If po
        AddElement(comments())
        comments()\addr=Mid(l$,1,4)
        comments()\remark=Mid(l$,po)
      EndIf
    Next i
  EndIf
  cp=$200
  eadr=$200+fs
  cursel=GetGadgetState(#da)
  anlab=GetMenuItemState(0,#opt_labels)
  ClearGadgetItems(#da)
  While cp<$200+fs
    Select t(cp)
      Case #type_pair
        d$=w2s(cp)+" .byte "+bb2s(PeekA(*m+cp))+" "+bb2s(PeekA(*m+cp+1))
        cp+2
        AddGadgetItem(#da,-1,d$)
        
      Case #type_byte
        d$=w2s(cp)+" .byte "+bb2s(PeekA(*m+cp))
        cp+1
        AddGadgetItem(#da,-1,d$)
        
      Case #type_code
        opcode=256*PeekA(*m+cp)+PeekA(*m+cp+1)
        x.a=(opcode&$0F00)>>8
        y.a=(opcode&$00F0)>>4
        n.a=opcode&$0F
        kk.a=opcode&$FF
        nnn.w=opcode&$0FFF
        d$= w2s(cp)+" "+bb2s(PeekA(*m+cp))+" "+bb2s(PeekA(*m+cp+1))+" ";+#TAB$
        Select (opcode>>12)&15                                         ;https://tonisagrista.com/blog/2021/chip8-spec/
          Case 0                                                       ;clear,return
            Select nnn
              Case $10
                d$=d$+"CALL $0010"
              Case $11
                d$=d$+"CALL $0011;EXIT"
              Case $C0 To $CF
                d$=d$+"CALL "+w2s(nnn)+"; scdown"
              Case $E0
                d$=d$+"CLS"
              Case $EE
                d$=d$+"RET"
              Default:
                If anlab
                  d$=d$+"CALL L"+w2s(nnn)
                  If nnn>$200 And nnn<eadr
                    AddElement(Labels())
                    Labels() = w2s(nnn)
                  EndIf
                Else
                  d$=d$+"CALL "+w2s(nnn)
                EndIf
            EndSelect
            
          Case 1;jump NNN
            If anlab
              d$=d$+"JP L"+w2s(nnn)
              If nnn>$200 And nnn<eadr
                AddElement(Labels())
                Labels() = w2s(nnn)
              EndIf
            Else
              d$=d$+"JP "+w2s(nnn)
            EndIf
          Case 2;call NNN
            If anlab
              d$=d$+"CALL L"+w2s(nnn)
              If nnn>$200 And nnn<eadr
                AddElement(Labels())
                Labels() = w2s(nnn)
              EndIf
            Else
              d$=d$+"CALL "+w2s(nnn)
            EndIf
          Case 3;
            If kk&128:kk=k-256:EndIf
            d$=d$+"SE V"+b2s(x)+","+bb2s(kk)
          Case 4
            If kk&128:kk=k-256:EndIf
            d$=d$+"SNE V"+b2s(x)+","+bb2s(kk)
          Case 5
            d$=d$+"SE V"+b2s(x)+",V"+b2s(y)
          Case 6
            If kk&128:kk=k-256:EndIf
            d$=d$+"LD V"+b2s(x)+","+bb2s(kk)
          Case 7
            If kk&128:kk=k-256:EndIf
            d$=d$+"ADD V"+b2s(x)+","+bb2s(kk)
          Case 8;special op
            Select n
              Case 0:
                d$=d$+"LD V"+b2s(x)+",V"+b2s(y)
              Case 1:
                d$=d$+"OR V"+b2s(x)+",V"+b2s(y)
              Case 2:
                d$=d$+"AND V"+b2s(x)+",V"+b2s(y)
              Case 3:
                d$=d$+"XOR V"+b2s(x)+",V"+b2s(y)
              Case 4:
                d$=d$+"ADD V"+b2s(x)+",V"+b2s(y)
              Case 5:
                d$=d$+"SUB V"+b2s(x)+",V"+b2s(y)
              Case 6:
                d$=d$+"SHR V"+b2s(x)
              Case 7:
                d$=d$+"SUBN V"+b2s(x)+",V"+b2s(y)
              Case 14:
                d$=d$+"SHL V"+b2s(x)
              Default: d$=d$+"unknown"
            EndSelect
          Case 9
            d$=d$+"SNE V"+bb2s(x)+",V"+b2s(y)
          Case 10
            If anlab
              d$=d$+"LD I,L"+w2s(nnn)
              If nnn>$200 And nnn<eadr
                AddElement(Labels())
                Labels() = w2s(nnn)
              EndIf
            Else
              d$=d$+"LD I,"+w2s(nnn)
            EndIf
          Case 11;
            d$=d$+"JP V"+w2s(nnn)
          Case 12
            d$=d$+"RND V"+b2s(x)+","+bb2s(kk)
          Case 13
            If n
              d$=d$+"DRAW V"+b2s(x)+",V"+b2s(y)+","+b2s(n)
            Else
              d$=d$+"DRAW V"+b2s(x)+",V"+b2s(y)
            EndIf
          Case 14
            Select kk
              Case $9E:
                d$=d$+"SKP V"+b2s(x)+",key"
              Case $A1
                d$=d$+"SKNP V"+b2s(x)
              Default: d$=d$+"unknown"
            EndSelect
          Case 15
            Select opcode&255
              Case $07
                d$=d$+"LD V"+b2s(x)+",DT"
              Case $0A
                d$=d$+"LD V"+b2s(x)+",K"
              Case $15
                d$=d$+"LD DT,V"+b2s(x)
              Case $18
                d$=d$+"LD ST,V"+b2s(x)
              Case $1E
                d$=d$+"ADD I,V"+b2s(x)
              Case $29
                d$=d$+"LD F,V"+b2s(x)
              Case $30
                d$=d$+"XHEX V"+b2s(x)
              Case $33
                d$=d$+"LD B,V"+b2s(x)
              Case $55
                d$=d$+"LD[I],V"+b2s(x)
              Case $65
                d$=d$+"LD V"+b2s(x)+",[I]"
              Case $75
                d$=d$+"FLAGS.SAVE V"+b2s(x)
              Case $85
                d$=d$+"FLAGS.RESTORE V"+b2s(x)
              Default:
                d$=d$+" unknown"
            EndSelect
        EndSelect
        AddGadgetItem(#da,-1,d$)
        cp+2
    EndSelect
  Wend
  nl=CountGadgetItems(#da)
  If nl
    ForEach Labels()
      ;Debug Labels()
      a$=Labels()
      For n=0 To nl-1
        l$=GetGadgetItemText(#da,n)
        If Mid(l$,1,4)=a$
          SetGadgetItemText(#da,n,"L"+l$)
        EndIf
      Next n
    Next
  EndIf
  
  ;ln=CountGadgetItems(#da)
  If nl
    For i=0 To nl-1
      l$=GetGadgetItemText(#da,i)
      If Mid(l$,1,1)="L"
        l$=Mid(l$,2)
      EndIf
      l$=Mid(l$,1,4)
      ForEach comments()
        ;   Debug comments()\addr+Chr(9)+comments()\remark
        If comments()\addr=l$
          SetGadgetItemText(#da,i,GetGadgetItemText(#da,i)+comments()\remark)
          Break
        EndIf
      Next
    Next i
    
  EndIf
  
  SetGadgetState(#da,cursel)
EndProcedure


Procedure loadfile(f$)
  fs=FileSize(f$)
  If fs>0
    If ReadFile(0,f$)
      ReadData(0,*m+$200,fs)
      CloseFile(0)
      das()
      spath$=GetFilePart(f$)
    Else
      fs=0
    EndIf
    
  Else
    fs=0
  EndIf
EndProcedure

For i=0 To 4095
  t(i)=#type_code
Next i

mitem=-1

If OpenWindow(0, 0, 0, 640, 420, "CHIP-8 disassembler", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#file_open, "Open"+Chr(9)+"Ctrl+O")
    MenuItem(#file_save, "Save"+Chr(9)+"Ctrl+S")
    MenuItem(#file_quit, "Quit"+Chr(9)+"Ctrl+Q")
    MenuTitle("Options")
    MenuItem(#opt_labels, "Analyze labels")
    SetMenuItemState(0,#opt_labels,1)
  EndIf
  
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_O, #file_open)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_S, #file_save)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_Q, #file_quit)
  If CreatePopupMenu(1)
    MenuItem(#mark_code, "mark as code")
    MenuItem(#mark_byte, "mark as byte")
    MenuItem(#mark_pair, "mark as pair byte")
    MenuBar()
    MenuItem(#mark_comment, "comment")
  EndIf
  
  
  ListViewGadget(#da, 0, 0, 640, 400)
  EnableGadgetDrop(#da,#PB_Drop_Files,#PB_Drag_Copy)
  
  ;--font
  If(OpenLibrary(0, "GDI32.DLL"))
    hfont=CallFunction(0, "AddFontMemResourceEx", ?font, (?end_font -?font), 0, @"1")
    LoadFont(0,"Dina",10)
    SetGadgetFont(#da,FontID(0))
    CloseLibrary(0)
  Else
    hfont=0
  EndIf 
  ;loadfile("clock.ch8")
  ;SetGadgetItemText(#da,0,GetGadgetItemText(#da,0)+";1st comment")
  ;SetGadgetItemText(#da,3,GetGadgetItemText(#da,3)+";4 comment")
  
  SPattern = 0 ;for open files
  spath$=GetCurrentDirectory()
  Repeat
    ev=WaitWindowEvent()
    Select ev
      Case #PB_Event_Menu
        Select EventMenu()
          Case #opt_labels
            SetMenuItemState(0,#opt_labels,1-GetMenuItemState(0,#opt_labels))
          Case #file_save
            Pattern$ = "Text (*.txt)|*.txt"
            File$ = SaveFileRequester("Please choose text file to save", spath$, Pattern$, 0)
            If File$
              Debug LCase(Right(File$,3))
              If LCase(Right(File$,3))<>"txt"
                File$+".txt"
              EndIf
              numw=CountGadgetItems(#da)
              If numw
                If CreateFile(0,File$)
                  For i=0 To numw-1
                    WriteStringN(0,GetGadgetItemText(#da,i),#PB_Ascii)
                  Next i
                  CloseFile(0)
                Else
                  MessageRequester("Save file","Error create file!")
                EndIf
              Else
                MessageRequester("Save file","nothing to save")
              EndIf
            EndIf
          Case #file_open
            Pattern$ = "CHIP-8 (*.ch8)|*.ch8|Binary (*.bin)|*.bin|All files (*.*)|*.*"
            File$ = OpenFileRequester("Please choose file to load", spath$, Pattern$, SPattern)
            If File$
              SPattern=SelectedFilePattern()
              loadfile(File$)
            EndIf
          Case #file_quit
            Break
          Case #mark_comment
            coml=GetGadgetState(#da)
            If coml>-1
              l$=GetGadgetItemText(#da,coml)
              p=FindString(l$,";")
              If p
                l1$=Mid(l$,1,p-1)
                l2$=Mid(l$,p+1)
              Else
                l1$=l$
                l2$=""
              EndIf
              l2$=InputRequester("Comment", "Please make your input:", l2$)
              If l2$<>""
                SetGadgetItemText(#da,coml,l1$+";"+l2$)
              EndIf
            EndIf
          Case #mark_code
            If mitem>0
              t(mitem)=#type_code
              t(mitem+1)=#type_code
              mitem=-1
              das()
            EndIf
          Case #mark_byte
            If mitem>0
              t(mitem)=#type_byte
              mitem=-1
              das()
            EndIf
          Case #mark_pair
            If mitem>0
              t(mitem)=#type_pair
              mitem=-1
              das()
            EndIf
            
        EndSelect
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #da
            Select EventType()
              Case #PB_EventType_LeftDoubleClick
                ;Debug "dbl"
              Case #PB_EventType_RightClick;If EventType()=#PB_EventType_RightClick
                                           ;-- context menu right click
                x = WindowMouseX(#da) : y = WindowMouseY(#da) 
                Gx = GadgetX(#da)
                Gw = GadgetX(#da) + GadgetWidth(#da)
                Gy = GadgetY(#da)
                Gh = GadgetY(#da) + GadgetHeight(#da) 
                #LB_ITEMFROMPOINT = $1A9
                If x >= Gx And x <= Gw And y >= Gy And y <= Gh 
                  h = SendMessage_(GadgetID(#da), #LB_GETITEMHEIGHT, 0, 0) 
                  ;y - (Round((h / 4) *3, 1)) 
                  Index = SendMessage_(GadgetID(#da), #LB_ITEMFROMPOINT, 0, x + (y<<16)) & $FFFF 
                  If Index > -1 
                    SendMessage_(GadgetID(ListView), #LB_SETCURSEL, Index, 0)
                    s$=Mid(GetGadgetItemText(#da,Index),1,4)
                    If s$
                      ;remove "L"
                      If Mid(s$,1,1)="L"
                        s$=Mid(GetGadgetItemText(#da,Index),1,5)
                        s$=Mid(s$,2)
                      EndIf
                      mitem=Val("$"+s$)
                      DisplayPopupMenu(1,WindowID(0))
                    EndIf 
                  EndIf 
                EndIf 
            EndSelect;EndIf
        EndSelect
        
      Case #PB_Event_GadgetDrop
        loadfile(EventDropFiles())
    EndSelect
  Until ev = #PB_Event_CloseWindow
EndIf
FreeMemory(*m)

If hfont
  If(OpenLibrary(0, "GDI32.DLL"))
    CallFunction(0, "RemoveFontMemResourceEx",hfont);<>0 if OK,0 if error
    CloseLibrary(0)
  EndIf
EndIf

DataSection
  font:
  IncludeBinary "DinaR.fon"
  end_font:
  ;fonts
  ;     0xF0, 0x90, 0x90, 0x90, 0xF0, // 0
  ;     0x20, 0x60, 0x20, 0x20, 0x70, // 1
  ;     0xF0, 0x10, 0xF0, 0x80, 0xF0, // 2
  ;     0xF0, 0x10, 0xF0, 0x10, 0xF0, // 3
  ;     0x90, 0x90, 0xF0, 0x10, 0x10, // 4
  ;     0xF0, 0x80, 0xF0, 0x10, 0xF0, // 5
  ;     0xF0, 0x80, 0xF0, 0x90, 0xF0, // 6
  ;     0xF0, 0x10, 0x20, 0x40, 0x40, // 7
  ;     0xF0, 0x90, 0xF0, 0x90, 0xF0, // 8
  ;     0xF0, 0x90, 0xF0, 0x10, 0xF0, // 9
  ;     0xF0, 0x90, 0xF0, 0x90, 0x90, // A
  ;     0xE0, 0x90, 0xE0, 0x90, 0xE0, // B
  ;     0xF0, 0x80, 0x80, 0x80, 0xF0, // C
  ;     0xE0, 0x90, 0x90, 0x90, 0xE0, // D
  ;     0xF0, 0x80, 0xF0, 0x80, 0xF0, // E
  ;     0xF0, 0x80, 0xF0, 0x80, 0x80, // F
; IDE Options = PureBasic 5.72 (Windows - x86)
; CursorPosition = 340
; FirstLine = 321
; Folding = -
; EnableXP
; UseIcon = dis.ico
; Executable = disasmc8.exe
; EnableUnicode