﻿Enumeration
  #cc
  ;labels Vx
  #lv0
  #lv1
  #lv2
  #lv3
  #lv4
  #lv5
  #lv6
  #lv7
  #lv8
  #lv9
  #lv10
  #lv11
  #lv12
  #lv13
  #lv14
  #lv15
  ;PC,I,SP
  #lpc
  #li
  #lsp
  ;values Vx
  #vv0
  #vv1
  #vv2
  #vv3
  #vv4
  #vv5
  #vv6
  #vv7
  #vv8
  #vv9
  #vv10
  #vv11
  #vv12
  #vv13
  #vv14
  #vv15
  ;PC,I,SP
  #vpc
  #vi
  #vsp
  ;disassembly
  #das
EndEnumeration

Enumeration;menus
  #file_open
  #file_quit
  #debug_reset
  #debug_run
  #debug_stop
  #debug_step
  #debug_toggleb
  #opt_loadrun
  #opt_inci
  #opt_skipu
EndEnumeration

Global pcstopat.l=-1
Global runningf.l
;-CHIP8 regs
; // Chip8
; 		unsigned char  gfx[64 * 32];	// Total amount of pixels: 2048
; 		unsigned char  key[16];
Global Dim gfx.a(64*32)
Global Dim key.a(16)
; 
; 	private:	
; 		unsigned short pc;				// Program counter
Global pc.u
; 		unsigned short opcode;			// Current opcode
Global opcode.u
; 		unsigned short I;				// Index register
Global i.u
; 		unsigned short sp;				// Stack pointer
Global sp.u
; 		
; 		unsigned char  V[16];			// V-regs (V0-VF)
Global Dim V.a(16)
; 		unsigned short stack[16];		// Stack (16 levels)
Global Dim stack.u(16)
; 		unsigned char  memory[4096];	// Memory (size = 4k)		
Global Dim memory.a(4096)
; 		unsigned char  delay_timer;		// Delay timer
Global delay_timer.a
; 		unsigned char  sound_timer;		// Sound timer	
Global sound_timer.a
Global drawFlag


Procedure.s s16(n.u)
  ProcedureReturn RSet(Hex(n),4,"0")
EndProcedure

Procedure.s b2s(b.b)
  ProcedureReturn Hex(b)
EndProcedure

Procedure.s bb2s(b.a)
  ProcedureReturn RSet(Hex(b),2,"0")
EndProcedure

; Procedure keyscan()
;   ;1234
;   If GetAsyncKeyState_(#VK_1)&32768
;     key(1)=1
;   Else
;     key(1)=0
;   EndIf
;   
;   If GetAsyncKeyState_(#VK_2)&32768
;     key(2)=1
;   Else
;     key(2)=0
;   EndIf
;   
;   If GetAsyncKeyState_(#VK_3)&32768
;     key(3)=1
;   Else
;     key(3)=0
;   EndIf
;   
;   If GetAsyncKeyState_(#VK_4)&32768
;     key($0C)=1
;   Else
;     key($0C)=0
;   EndIf
;   ;qwer
;   ;asdf
;   ;zxcv
; EndProcedure

Procedure stp()
  skipundef=GetMenuItemState(0,#opt_skipu)
  If pc=4096
    MessageRequester("Chip-8","PC reached limit")
    runningf=0
    ProcedureReturn
  EndIf
  ; 	// Fetch opcode
  opcode = (memory(pc) << 8) | memory(pc + 1)
  ; 	// Process opcode
  Select opcode & $F000
    Case $0000:
      Select opcode & $000F
        Case $0000:; // 0x00E0: Clears the screen
          For j=0 To 2047
            gfx(j)=0
          Next j
          drawFlag = 1
          pc+2
        Case $000E:; // 0x00EE: Returns from subroutine
          sp=sp-1
          pc=stack(sp);	// Put the stored return address from the stack back into the program counter					
          pc+2        ;		// Don't forget to increase the program counter!
        Default:
          If skipundef
            pc+2
          Else
            runningf=0
            MessageRequester("CHIP-8","unknown opcode:"+s16(opcode)+" at:"+s16(pc))
          EndIf
      EndSelect
    Case $1000:; // 0x1NNN: Jumps To address NNN
      pc = opcode & $0FFF;
    Case $2000:          ; // 0x2NNN: Calls subroutine at NNN.
      stack(sp) = pc     ;			// Store current address in stack
      sp+1               ;					// Increment stack pointer
      pc = opcode & $0FFF;	// Set the program counter to the address at NNN
    Case $3000:          ; // 0x3XNN: Skips the Next instruction If VX equals NN
      If(V((opcode & $0F00) >> 8) = (opcode & $00FF))
        pc + 4;
      Else
        pc + 2;
      EndIf
    Case $4000:; // 0x4XNN: Skips the Next instruction If VX doesn't equal NN
      If(V((opcode & $0F00) >> 8) <> (opcode & $00FF))
        pc + 4;
      Else
        pc + 2;
      EndIf
    Case $5000:; // 0x5XY0: Skips the Next instruction If VX equals VY.
      If(V((opcode & $0F00) >> 8) = V((opcode & $00F0) >> 4))
        pc + 4
      Else
        pc + 2
      EndIf
    Case $6000:; // 0x6XNN: Sets VX To NN.
      V((opcode & $0F00) >> 8) = opcode & $00FF
      pc +2
    Case $7000:; // 0x7XNN: Adds NN To VX.
      V((opcode & $0F00) >> 8) + (opcode & $00FF)
      pc +2;
    Case $8000:
      Select opcode & $000F
        Case $0000:; // 0x8XY0: Sets VX To the value of VY
          V((opcode & $0F00) >> 8) = V((opcode & $00F0) >> 4)
          pc + 2;
        Case $0001:; // 0x8XY1: Sets VX To "VX OR VY"
          V((opcode & $0F00) >> 8)= V((opcode & $0F00) >> 8)| V((opcode & $00F0) >> 4)
          pc + 2;
        Case $0002:; // 0x8XY2: Sets VX To "VX AND VY"
          V((opcode & $0F00) >> 8)=V((opcode & $0F00) >> 8) & V((opcode & $00F0) >> 4)
          pc + 2;
        Case $0003:; // 0x8XY3: Sets VX To "VX XOR VY"
          V((opcode & $0F00) >> 8)=V((opcode & $0F00) >> 8)!V((opcode & $00F0) >> 4)
          pc + 2;
        Case $0004:; // 0x8XY4: Adds VY To VX. VF is set To 1 when there's a carry, and to 0 when there isn't					
          If(V((opcode & $00F0) >> 4) > ($FF - V((opcode & $0F00) >> 8))) 
            V($0F) = 1; //carry
          Else 
            V($0F) = 0;
          EndIf
          V((opcode & $0F00) >> 8) + V((opcode & $00F0) >> 4)
          pc +2
        Case $0005:; // 0x8XY5: VY is subtracted from VX. VF is set To 0 when there's a borrow, and 1 when there isn't
          If V((opcode & $00F0) >> 4) > V((opcode & $0F00) >> 8)
            V($0F) = 0; // there is a borrow
          Else 
            V($0F) = 1;					
          EndIf
          V((opcode & $0F00) >> 8) - V((opcode & $00F0) >> 4)
          pc + 2;
        Case $0006:; // 0x8XY6: Shifts VX right by one. VF is set To the value of the least significant bit of VX before the shift
          V($0F) = V((opcode & $0F00) >> 8)&1
          V((opcode & $0F00) >> 8) >> 1
          pc + 2
        Case $0007:; // 0x8XY7: Sets VX To VY minus VX. VF is set To 0 when there's a borrow, and 1 when there isn't
          If(V((opcode & $0F00) >> 8) > V((opcode & $00F0) >> 4));	// VY-VX
            V($0F) = 0                                           ; // there is a borrow
          Else
            V($0F) = 1
          EndIf
          V((opcode & $0F00) >> 8) = V((opcode & $00F0) >> 4) - V((opcode & $0F00) >> 8)
          pc + 2;
        Case $000E:; // 0x8XYE: Shifts VX left by one. VF is set To the value of the most significant bit of VX before the shift
          V($0F) = V((opcode & $0F00) >> 8) >> 7
          V((opcode & $0F00) >> 8) << 1
          pc + 2
        Default:
          If skipundef
            pc+2
          Else
            runningf=0
            MessageRequester("CHIP-8","unknown opcode:"+s16(opcode)+" at:"+s16(pc))
          EndIf
      EndSelect
    Case $9000:; // 0x9XY0: Skips the Next instruction If VX doesn't equal VY
      If(V((opcode & $0F00) >> 8) <> V((opcode & $00F0) >> 4))
        pc + 4
      Else
        pc + 2
      EndIf
    Case $A000:; // ANNN: Sets I To the address NNN
      I = opcode & $0FFF;
      pc + 2
    Case $B000:; // BNNN: Jumps To the address NNN plus V0
      pc = (opcode & $0FFF) + V(0)
    Case $C000:; // CXNN: Sets VX To a random number And NN
      V((opcode & $0F00) >> 8) = (Random(255)) & (opcode & $00FF);
      pc + 2
    Case $D000:
      ; // DXYN: Draws a sprite at coordinate (VX, VY) that has a width of 8 pixels And a height of N pixels. 
      ; 					 // Each row of 8 pixels is Read As bit-coded starting from memory location I; 
      ; 					 // I value doesn't change after the execution of this instruction. 
      ; 					 // VF is set To 1 If any screen pixels are flipped from set To unset when the sprite is drawn, 
      ; 					 // And To 0 If that doesn't happen
      x.u = V((opcode & $0F00) >> 8)
      y.u = V((opcode & $00F0) >> 4)
      height.u = opcode & $000F
      V($0F) = 0
      If height ; check?
        For yline = 0 To height -1
          pixel.u = memory(I + yline)
          
          ccy=(y + yline)&31
          For xline = 0 To 7
            ccx=(x + xline)&63
            If pixel & ($80 >> xline)
              ;;            If gfx((x + xline + ((y + yline) * 64))) = 1
              If gfx((ccx + (ccy * 64))) = 1
                V($0F) = 1
              EndIf
              ;;            gfx(x + xline + ((y + yline) * 64))=gfx(x + xline + ((y + yline) * 64))!1;
              gfx(ccx + ccy * 64)=gfx(ccx+ ccy * 64)!1;
            EndIf
          Next xline
        Next yline
        drawFlag = 1
        pc + 2
      EndIf
    Case $E000:
      Select opcode & $00FF
        Case $009E:; // EX9E: Skips the Next instruction If the key stored in VX is pressed
          If key(V((opcode & $0F00) >> 8))<>0
            pc + 4
          Else
            pc + 2
          EndIf
        Case $00A1:; // EXA1: Skips the Next instruction If the key stored in VX isn't pressed
          If key(V((opcode & $0F00) >> 8))=0
            pc + 4
          Else
            pc + 2
          EndIf
        Default:
          If skipundef
            pc+2
          Else
            runningf=0
            MessageRequester("CHIP-8","unknown opcode $E000:"+s16(opcode)+" at:"+s16(pc))
          EndIf
      EndSelect
    Case $F000:
      Select opcode & $00FF
        Case $0007:; // FX07: Sets VX To the value of the delay timer
          V((opcode & $0F00) >> 8) = delay_timer;
          pc +2
        Case $000A:; // FX0A: A key press is awaited, And then stored in VX		
          keyPress = 0
          For j=0 To 15
            If key(j)
              V((opcode & $0F00) >> 8) = j
              keyPress = 1
            EndIf
          Next j
          ; 					// If we didn't received a keypress, skip this cycle and try again.
          ; 					If(!keyPress)						
          ; 						Return;
          If keyPress
            pc + 2
          EndIf
        Case $0015;// FX15: Sets the delay timer To VX
          delay_timer = V((opcode & $0F00) >> 8)
          pc +2;
        Case $0018:;// FX18: Sets the sound timer To VX
          sound_timer = V((opcode & $0F00) >> 8)
          pc +2;
        Case $001E:; // FX1E: Adds VX To I
          If(I + V((opcode & $0F00) >> 8) > $FFF);VF is set To 1 when range overflow (I+VX>0xFFF), And 0 when there isn't.
            V($0F) = 1                           ;
          Else
            V($0F) = 0;
          EndIf
          I + V((opcode & $0F00) >> 8)
          pc + 2;
        Case $0029:; // FX29: Sets I To the location of the sprite For the character in VX. Characters 0-F (in hexadecimal) are represented by a 4x5 font
          I = V((opcode & $0F00) >> 8) *5;
          pc +2
        Case $0033:; // FX33: Stores the Binary-coded decimal representation of VX at the addresses I, I plus 1, And I plus 2
          memory(I)     = V((opcode & $0F00) >> 8) / 100;
          memory(I + 1) = (V((opcode & $0F00) >> 8) / 10) % 10;
          memory(I + 2) = (V((opcode & $0F00) >> 8) % 100) % 10;					
          pc + 2
        Case $0055:; // FX55: Stores V0 To VX in memory starting at address I					
          For j = 0 To ((opcode & $0F00) >> 8)
            memory(I + j) = V(j)
          Next j
          
          If  GetMenuItemState(0,#opt_inci)
            ;// On the original interpreter, when the operation is done, I = I + X + 1.
            I =I+((opcode & $0F00) >> 8) + 1
          EndIf
          pc +2
        Case $0065:; // FX65: Fills V0 To VX With values from memory starting at address I					
          For j = 0 To (opcode & $0F00) >> 8
            V(j) = memory(I + j)
          Next j
          If GetMenuItemState(0,#opt_inci)
            ;// On the original interpreter, when the operation is done, I = I + X + 1.
            I =I+((opcode & $0F00) >> 8) + 1;
          EndIf
          pc + 2
        Default:
          If skipundef
            pc+2
          Else
            runningf=0
            MessageRequester("CHIP-8","unknown opcode $F000:"+s16(opcode)+" at:"+s16(pc))
          EndIf
      EndSelect
    Default:
      If skipundef
        pc+2
      Else
        runningf=0
        MessageRequester("CHIP-8","unknown opcode:"+s16(opcode)+" at:"+s16(pc))
      EndIf
  EndSelect
  ; 	// Update timers
  If delay_timer > 0
    delay_timer-1
  EndIf
  
  If(sound_timer > 0)
    If sound_timer = 1
      ; 			printf("BEEP!\n");
      ;Debug "beep"
      ;Beep_(150,40); Buzz Beep Sound at speakers
      SetSoundFrequency(0, 45000+(sound_timer*100))
      PlaySound(0,0,25); Play beep sound
      
      sound_timer-1
    EndIf
  EndIf
  ; }//emulate
EndProcedure
Procedure initchip8()
  pc=$200
  i=0
  sp=0
  
  For j=0 To 2047:gfx(j)=0:Next j
  
  For j=0 To 15:stack(j)=0:Next j
  
  For j=0 To 4095:memory(j)=0:Next j
  
  Restore chip8_fontset
  For j=0 To 79:Read.a memory(j):Next j
  
  delay_timer = 0;
  sound_timer = 0;
  
  drawFlag = 1
  
  RandomSeed($12345)
EndProcedure


Procedure drawchip8()
  If drawFlag
    If StartDrawing(CanvasOutput(#cc))
      Box(0,0,640,320,0)
      For y=0 To 31
        For x=0 To 64
          If gfx(y*64+x)
            col=$FFFFFF
          Else
            col=0
          EndIf
          Box(x*10,y*10,10,10,col)
        Next x
      Next y
      StopDrawing()
    EndIf;If StartDrawing(CanvasOutput(#cc))
    drawFlag = 0
  EndIf
  
EndProcedure

Procedure updregs()
  SetGadgetText(#vpc,s16(pc))
  SetGadgetText(#vi,s16(i))
  SetGadgetText(#vsp,s16(sp))
  
  For j=0 To 15
    SetGadgetText(#vv0+j,s16(V(j)))
    ;InvalidateRect_(GadgetID(#vv0+j), 0, 1)
    ;RedrawWindow_(GadgetID(#vv0+j), 0, 0, 7)
    ;     SendMessage_(WindowID(0),#WM_SETREDRAW,#True,0)
    ;     RedrawWindow_(WindowID(0),#Null,#Null,#RDW_INVALIDATE)
  Next j
EndProcedure

Procedure disas(apc)
  ;   If apc>=4096
  ;     ProcedureReturn
  ;   EndIf
  cp=apc
  For j=0 To 23
    If cp>=4096
      Break
    EndIf
    
    opcode=256*memory(cp)+memory(cp+1)
    x.a=(opcode&$0F00)>>8
    y.a=(opcode&$00F0)>>4
    n.a=opcode&$0F
    kk.a=opcode&$FF
    nnn.w=opcode&$0FFF
    d$= s16(cp)+" "+bb2s(memory(cp))+" "+bb2s(memory(cp+1))+" "
    Select (opcode>>12)&15;https://tonisagrista.com/blog/2021/chip8-spec/
      Case 0              ;clear,return
        Select nnn
          Case $10
            d$=d$+"CALL $0010"
          Case $11
            d$=d$+"CALL $0011; EXIT"
          Case $C0 To $CF
            d$=d$+"CALL "+s16(nnn)+"; scdown"
          Case $E0
            d$=d$+"CALL $00E0; CLS"
          Case $EE
            d$=d$+"RET"
          Default:
            d$=d$+"CALL "+s16(nnn)
        EndSelect
      Case 1;jump NNN
        d$=d$+"JP "+s16(nnn)
      Case 2;call NNN
        d$=d$+"CALL "+s16(nnn)
      Case 3;
        If kk&128:kk=k-256:EndIf
        d$=d$+"SE V"+b2s(x)+","+bb2s(kk)
      Case 4
        If kk&128:kk=k-256:EndIf
        d$=d$+"SNE V"+b2s(x)+","+bb2s(kk)
      Case 5
        d$=d$+"SE V"+b2s(x)+",V"+b2s(y)
      Case 6
        If kk&128:kk=k-256:EndIf
        d$=d$+"LD V"+b2s(x)+","+bb2s(kk)
      Case 7
        If kk&128:kk=k-256:EndIf
        d$=d$+"ADD V"+b2s(x)+","+bb2s(kk)
      Case 8;special op
        Select n
          Case 0:
            d$=d$+"LD V"+b2s(x)+",V"+b2s(y)+";Vx=Vy"
          Case 1:
            d$=d$+"OR V"+b2s(x)+",V"+b2s(y)
          Case 2:
            d$=d$+"AND V"+b2s(x)+",V"+b2s(y)
          Case 3:
            d$=d$+"XOR V"+b2s(x)+",V"+b2s(y)
          Case 4:
            d$=d$+"ADD V"+b2s(x)+",V"+b2s(y)
          Case 5:
            d$=d$+"SUB V"+b2s(x)+",V"+b2s(y)
          Case 6:
            d$=d$+"SHR V"+b2s(x)
          Case 7:
            d$=d$+"SUBN V"+b2s(x)+",V"+b2s(y)
          Case 14:
            d$=d$+"SHL V"+b2s(x)
          Default: d$=d$+"unknown"
        EndSelect
      Case 9
        d$=d$+"SNE V"+bb2s(x)+",V"+b2s(y)
      Case 10
        d$=d$+"LD I,"+s16(nnn)
      Case 11;
        d$=d$+"JP V"+s16(nnn)
      Case 12
        d$=d$+"RND V"+b2s(x)+","+bb2s(kk)
      Case 13
        If n
          d$=d$+"DRAW V"+b2s(x)+",V"+b2s(y)+","+b2s(n)
        Else
          d$=d$+"DRAW V"+b2s(x)+",V"+b2s(y)
        EndIf
      Case 14
        Select kk
          Case $9E:
            d$=d$+"SKP V"+b2s(x)+",key"
          Case $A1
            d$=d$+"SKNP V"+b2s(x)
          Default: d$=d$+"unknown"
        EndSelect
      Case 15
        Select opcode&255
          Case $07
            d$=d$+"LD V"+b2s(x)+",DT"
          Case $0A
            d$=d$+"LD V"+b2s(x)+",K"
          Case $15
            d$=d$+"LD DT,V"+b2s(x)
          Case $18
            d$=d$+"LD ST,V"+b2s(x)
          Case $1E
            d$=d$+"ADD I,V"+b2s(x)
          Case $29
            d$=d$+"LD F,V"+b2s(x)
          Case $30
            d$=d$+"XHEX V"+b2s(x)
          Case $33
            d$=d$+"LD B,V"+b2s(x)
          Case $55
            d$=d$+"LD[I],V"+b2s(x)
          Case $65
            d$=d$+"LD V"+b2s(x)+",[I]"
          Case $75
            d$=d$+"FLAGS.SAVE V"+b2s(x)
          Case $85
            d$=d$+"FLAGS.RESTORE V"+b2s(x)
          Default:
            d$=d$+" unknown"
        EndSelect
    EndSelect
    AddGadgetItem(#das,j,d$)
    If pc=cp
      SetGadgetState(#das,j)
    EndIf
    cp+2
  Next j
EndProcedure

Procedure findpc()
  itm=CountGadgetItems(#das)
  notf=1
  If itm>=0
    For j=0 To itm
      i$=Mid(GetGadgetItemText(#das,j),1,4)
      If i$=s16(pc)
        SetGadgetState(#das,j)
        notf=0
        Break
      EndIf
    Next j
    If notf
      ClearGadgetItems(#das)
      disas(pc)
    EndIf
  EndIf
EndProcedure

Procedure loadfile(f$)
  If ReadFile(0,f$)
    runningf=0
    ppos=$200
    While Not Eof(0)
      memory(ppos)=ReadAsciiCharacter(0)
      ppos+1
    Wend
    CloseFile(0)
    disas($200)
    findpc()
    updregs()
    If GetMenuItemState(0,#opt_loadrun)
      runningf=1
    EndIf
  Else
    MessageRequester("CHIP-8","Error read "+f$)
  EndIf
EndProcedure

Procedure writeini()
  If CreatePreferences("c8d.ini",#PB_Preference_GroupSeparator)
    PreferenceGroup("options")
    WritePreferenceLong ("loadrun", GetMenuItemState(0,#opt_loadrun))
    WritePreferenceLong ("inci", GetMenuItemState(0,#opt_inci))
    WritePreferenceLong ("skipu", GetMenuItemState(0,#opt_skipu))
    ClosePreferences()
  Else
    MessageRequester("Error","Error create c8d.ini!")
  EndIf
EndProcedure

Procedure MyWindowCallback(WindowID,Message,wParam,lParam)
  Result=#PB_ProcessPureBasicEvents
  Select Message
    Case #WM_KEYDOWN
      ;1234
      Select UCase(Chr(wParam))
        Case "1":key(1)=1
        Case "2":key(2)=1
        Case "3":key(3)=1
        Case "4":key($0C)=1
          ;qwer
        Case "Q":key(4)=1
        Case "W":key(5)=1
        Case "E":key(6)=1
        Case "R":key($0D)=1
          ;asdf
        Case "A":key(7)=1
        Case "S":key(8)=1
        Case "D":key(9)=1
        Case "F":key($0E)=1
          ;zxcv
        Case "Z":key($0A)=1
        Case "X":key($00)=1
        Case "C":key($0B)=1
        Case "V":key($0F)=1
      EndSelect
      
    Case #WM_KEYUP
      ;1234
      Select UCase(Chr(wParam))
        Case "1":key(1)=0
        Case "2":key(2)=0
        Case "3":key(3)=0
        Case "4":key($0C)=0
          ;qwer
        Case "Q":key(4)=0
        Case "W":key(5)=0
        Case "E":key(6)=0
        Case "R":key($0D)=0
          ;asdf
        Case "A":key(7)=0
        Case "S":key(8)=0
        Case "D":key(9)=0
        Case "F":key($0E)=0
          ;zxcv
        Case "Z":key($0A)=0
        Case "X":key($00)=0
        Case "C":key($0B)=0
        Case "V":key($0F)=0
      EndSelect
      
  EndSelect
  ProcedureReturn Result
EndProcedure


InitSound()
CatchSound(0, ?BEEP)
runningf=0
initchip8()
;loadfile("BC_test.ch8")
;--main windows
If OpenWindow(0, 0, 0, 800, 600, "CHIP-8", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  CanvasGadget(#cc, 0, 40, 640, 320)
  EnableGadgetDrop(#cc,#PB_Drop_Files,#PB_Drag_Copy)
  ListViewGadget(#das,640,40,160,320)
  TextGadget(#lv0,0,0,20,20,"V0",#PB_Text_Right)
  StringGadget(#vv0,20,0,40,20,"0000",#ES_RIGHT)
  TextGadget(#lv1,0,20,20,20,"V1",#PB_Text_Right)
  StringGadget(#vv1,20,20,40,20,"0001",#ES_RIGHT)
  TextGadget(#lv2,60,0,20,20,"V2",#PB_Text_Right)
  StringGadget(#vv2,80,0,40,20,"0002",#ES_RIGHT)
  TextGadget(#lv3,60,20,20,20,"V3",#PB_Text_Right)
  StringGadget(#vv3,80,20,40,20,"0003",#ES_RIGHT)
  
  TextGadget(#lv4,120,0,20,20,"V4",#PB_Text_Right)
  StringGadget(#vv4,140,0,40,20,"0004",#ES_RIGHT)
  TextGadget(#lv5,120,20,20,20,"V5",#PB_Text_Right)
  StringGadget(#vv5,140,20,40,20,"0005",#ES_RIGHT)
  
  TextGadget(#lv6,180,0,20,20,"V6",#PB_Text_Right)
  StringGadget(#vv6,200,0,40,20,"0006",#ES_RIGHT)
  TextGadget(#lv7,180,20,20,20,"V7",#PB_Text_Right)
  StringGadget(#vv7,200,20,40,20,"0007",#ES_RIGHT)
  
  TextGadget(#lv8,240,0,20,20,"V8",#PB_Text_Right)
  StringGadget(#vv8,260,0,40,20,"0008",#ES_RIGHT)
  TextGadget(#lv9,240,20,20,20,"V9",#PB_Text_Right)
  StringGadget(#vv9,260,20,40,20,"0009",#ES_RIGHT)
  
  TextGadget(#lv10,300,0,20,20,"V0A",#PB_Text_Right)
  StringGadget(#vv10,320,0,40,20,"000A",#ES_RIGHT)
  TextGadget(#lv11,300,20,20,20,"V0B",#PB_Text_Right)
  StringGadget(#vv11,320,20,40,20,"000B",#ES_RIGHT)
  
  TextGadget(#lv12,360,0,20,20,"V0C",#PB_Text_Right)
  StringGadget(#vv12,380,0,40,20,"000C",#ES_RIGHT)
  TextGadget(#lv13,360,20,20,20,"V0D",#PB_Text_Right)
  StringGadget(#vv13,380,20,40,20,"000D",#ES_RIGHT)
  
  TextGadget(#lv14,420,0,20,20,"V0E",#PB_Text_Right)
  StringGadget(#vv14,440,0,40,20,"000E",#ES_RIGHT)
  TextGadget(#lv15,420,20,20,20,"V0F",#PB_Text_Right)
  StringGadget(#vv15,440,20,40,20,"000F",#ES_RIGHT)
  
  TextGadget(#lpc,480,0,20,20,"PC",#PB_Text_Right)
  StringGadget(#vpc,500,0,40,20,"0000",#ES_RIGHT)
  TextGadget(#li,480,20,20,20,"I",#PB_Text_Right)
  StringGadget(#vi,500,20,40,20,"0000",#ES_RIGHT)
  
  TextGadget(#lsp,540,0,20,20,"SP",#PB_Text_Right)
  StringGadget(#vsp,560,0,40,20,"0000",#ES_RIGHT)
  
  
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#file_open, "Open"+Chr(9)+"Ctrl+O")
    MenuBar()
    MenuItem(#file_quit, "Quit")
    MenuTitle("Debug")
    MenuItem(#debug_step, "Step"+Chr(9)+"F7")
    MenuBar()
    MenuItem(#Debug_run, "Run"+Chr(9)+"F5")
    MenuItem(#Debug_stop, "Stop")
    MenuBar()
    MenuItem(#Debug_reset, "Reset")
    MenuItem(#debug_toggleb, "Toggle breakpoint")
    MenuTitle("Options")
    MenuItem(#opt_loadrun, "Run after load")
    MenuItem(#opt_inci, "Increase I on FX55/FX65")
    MenuItem(#opt_skipu, "Skip undefined opcodes")
    AddKeyboardShortcut(0, #PB_Shortcut_F7,#debug_step)
    AddKeyboardShortcut(0, #PB_Shortcut_F5,#debug_run)
    AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_O, #file_open)
  EndIf
  ;--read .ini, setup
  If OpenPreferences("c8d.ini")
    PreferenceGroup("options")
    SetMenuItemState(0,#opt_loadrun,ReadPreferenceLong("loadrun", 1))
    SetMenuItemState(0,#opt_inci,ReadPreferenceLong("inci", 1))
    SetMenuItemState(0,#opt_skipu,ReadPreferenceLong("skipu", 1))
    ClosePreferences()
  EndIf
  If CountProgramParameters()
    loadfile(ProgramParameter(0))
  EndIf
  
  spa$=GetCurrentDirectory()
  disas($200)
  findpc()
  updregs()
  drawchip8()
  SetWindowCallback(@MyWindowCallback())
  AddWindowTimer(0,123,1)
  
  Repeat
    Event = WindowEvent()
    If runningf
      If pc=pcstopat
        runningf=0
      Else
        stp()
        findpc()
        drawchip8()
        Sleep_(10)
      EndIf
    EndIf
    
    Select Event
      Case #PB_Event_Timer 
        
      Case #PB_Event_GadgetDrop
        loadfile(EventDropFiles())
      Case #PB_Event_Gadget
        Select EventGadget()
        EndSelect
      Case #PB_Event_Menu
        Select EventMenu()
          Case #file_open
            Pattern$ = "CHIP-B (*.ch8)|*.ch8|Binary (*.bin)|*.bin|All files (*.*)|*.*"
            File$ = OpenFileRequester("Please choose file to load", spa$, Pattern$,0)
            If File$
              spa$=GetPathPart(File$)
              loadfile(File$)
            EndIf
          Case #file_quit
            Break
          Case #opt_skipu
            p=1-GetMenuItemState(0,#opt_skipu)
            SetMenuItemState(0,#opt_skipu,p)
            writeini()
          Case #opt_loadrun
            p=1-GetMenuItemState(0,#opt_loadrun)
            SetMenuItemState(0,#opt_loadrun,p)
            writeini()
          Case #opt_inci
            p=1-GetMenuItemState(0,#opt_inci)
            SetMenuItemState(0,#opt_inci,p)
            writeini()
          Case #debug_reset
            runningf=0
            initchip8()
      ClearGadgetItems(#das)
            disas($200)
            updregs()
            findpc()
            drawchip8()
          Case #debug_toggleb
            seli=GetGadgetState(#das)
            If seli>-1
              s$=Mid(GetGadgetItemText(#das,seli),1,4)
              bpc=Val("$"+s$)
              If pcstopat=bpc
                pcstopat=-1
              Else
                pcstopat=bpc
              EndIf
              ;Debug s16(pcstopat)
            EndIf
          Case #debug_run
            runningf=1
          Case #debug_stop
            runningf=0
            updregs()
            findpc()
            drawchip8()
          Case #debug_step
            stp()
            updregs()
            findpc()
            drawchip8()
        EndSelect
    EndSelect
  Until Event = #PB_Event_CloseWindow
  writeini()
EndIf


DataSection
  chip8_fontset:
  Data.a    $F0, $90, $90, $90, $F0;, //0
  Data.a    $20, $60, $20, $20, $70;, //1
  Data.a    $F0, $10, $F0, $80, $F0;, //2
  Data.a    $F0, $10, $F0, $10, $F0;, //3
  Data.a    $90, $90, $F0, $10, $10;, //4
  Data.a    $F0, $80, $F0, $10, $F0;, //5
  Data.a    $F0, $80, $F0, $90, $F0;, //6
  Data.a    $F0, $10, $20, $40, $40;, //7
  Data.a    $F0, $90, $F0, $90, $F0;, //8
  Data.a    $F0, $90, $F0, $10, $F0;, //9
  Data.a    $F0, $90, $F0, $90, $90;, //A
  Data.a    $E0, $90, $E0, $90, $E0;, //B
  Data.a    $F0, $80, $80, $80, $F0;, //C
  Data.a    $E0, $90, $90, $90, $E0;, //D
  Data.a    $F0, $80, $F0, $80, $F0;, //E
  Data.a    $F0, $80, $F0, $80, $80;  //F
  BEEP:
  IncludeBinary "beep.wav"

; IDE Options = PureBasic 5.72 (Windows - x86)
; CursorPosition = 849
; FirstLine = 835
; Folding = ---
; EnableXP
; UseIcon = c8d.ico
; Executable = c8d.exe
; EnableUnicode